# **环境需求**

- php 5.5~7.2 （不要用PHP8！会影响smarty 2.5）
- ffmpeg 任意版本 （用于富文本HTML中的gif转换静音mp4）
- 其它常规lnmp+redis环境配置
- 补充资料：
    - <svn://svn.webdev.ouj.com/biz/cms/doc/生产环境/环境部署-201911.txt>
    - <svn://svn.webdev.ouj.com/biz/cms/doc/生产环境/nginx-20221111-news.ouj.com-backup.conf>
    - <svn://svn.webdev.ouj.com/biz/cms/doc/生产环境/nginx-20221111-wot.ouj.com-backup.conf>

# **静态模板及资源目录**

> `/data/cms_data` @ 120.77.43.65 （后台机）

> 该目录是原始目录。
> 
> 对于另外两台前端机（47.106.73.57和47.106.163.152）的`/data/cms_data`目录，都是通过`sersync`，由后台机向前端机，执行单向同步。

### 文件分布概要

> - 文章存放：/data/cms_data/article/{专区ID}/{年周}/{文章ID}[_可选页码].html
> - 标签页存放：/data/cms_data/tag/{专区ID}/{标签ID}.html
> - 模板最终页存放：/data/cms_data/tpl/{专区ID}/{模板ID}.html
> - 模板最终页(自定义路径)存放：/data/cms_data/tpl/{专区ID}/diy/{自定义路径}
> - 文件存放：/data/cms_data/s/{文件路径}
> - 图片存放：/data/cms_data/s/{图片路径} #这个不一定考虑


### 目录树状结构
- article  //文章最终页
    - wot 
        - 2252 //年周，date('yW')
            - 1641008667882.html
            - 1641106990833.html
            - 文章ID.html ……
        - 1928
        - ……
    - yxdt
    - ceshi
    - test
    - 其他专区的channel值 ……
- s //自定义文件路径上传
    - wot
        - external //外部抓取的富文本资源，会放到此目录
            > 详见 后台 `api/TestMigrateByContent` 页面 和 `/api/MigrateByContent` 接口，核心代码 `ResourceMigrateLog::migrateByContent()`

    - yxdt
    - 其他专区的channel值 ……
- tag //标签页模板
    - wot 
        - 188.html
        - 189.html
        - 标签ID.html ...
    - yxdt
- tpl //普通页模板
    - wot 
        - 192821021540.html
        - 1587008388815.html
        - 模板ID.html ...
        - diy //自定义URI的模板目录，可随意设定目录层级
            - a/b/c/12345.html
            - wwoott/sbbb/hehe.html
            - ...

    - yxdt
    - 其他专区的channel值 ……

- 其他专区的channel值 ……

---

<br>



# **web目录与资源目录软链接配置**
> /data/cms_data @ 47.106.73.57|47.106.163.152

> 只有这两台前端机做软链，后台的不用

### web目录软链

> 位于 /data/webapps/news.ouj.com

- article -> /data/cms_data/article
- s -> /data/cms_data/s
- tag -> /data/cms_data/tag
- tpl -> /data/cms_data/tpl





# **定时任务**

> 机器：120.77.43.65

任务列表（由pm2管理，详见pm2 list和pm2 info 任务ID）

- 定期刷新标签页
    /usr/local/php/bin/php /data/webapps/cms.ouj.com/cli.php cron/RefreshTagPage >> /tmp/CmsRefreshTagPage.log # 要以www-data身份执行，由PM2管理

- 刷新文章页

    /usr/local/php/bin/php /data/webapps/cms.ouj.com/cli.php cron/RefreshArticlePage >> /tmp/RefreshArticlePage.log # 要以www-data身份执行，由PM2管理

- 页游首页广告推广位点击队列（消费）

     /usr/local/php/bin/php /data/webapps/pgame-admin.ouj.com/cli.php bin/adPosClickConsume # 要以www-data身份执行，由PM2管理

- 同步游戏角色

     /usr/local/php/bin/php /data/webapps/pgame-admin.ouj.com/cli.php bin/syncRoleRelate # 要以www-data身份执行，由PM2管理

- 消费【为及时同步角色数据，专用的游戏登录队列】

    /usr/local/php/bin/php /data/webapps/pgame-admin.ouj.com/cli.php bin/login4RolesQueueConsume # 要以www-data身份执行，由PM2管理
