# **基本概念释疑**

> shoes_开头的都是生产管理的表

> 其中，shoes_accessory/shoes_component/shoes_part的字段相似，用于保存每个生产批次中的`[具体生产细节]`。

> 作为`[具体生产细节]`的前提，一种被称为`[生产要素]`的概念，被发明出来。存储表为`shoes_produce_catagories`。
> 
> 它被认为是具体生产细节的模板。

> 当`[生产要素]`跟`[供应商]`(shoes_supplier)结合后，就有了`[具体生产细节]`数据，这些数据将保存在每个批次中。
>
> ***（说人话，就是指定哪个厂商，提供哪种生产要素(生产资料)）***

---
<br>

# **生产要素分类**

> 其定义见上文

- 出厂大货配件(accessory)

    > 代码搜索关键词：shoes_accessory, acc, accessory, accessories, sa

    > 数据案例：包装盒、说明书、充电底座

- 鞋体部位(part)

    > 代码搜索关键词：shoes_part, part, sprt

    > 数据案例：蓝牙芯片、IMU芯片、充电芯片、电池、地磁传感器

- 电子元件(component)

    > 代码搜索关键词：shoes_component, compo, component, sc

    > 数据案例：蓝牙芯片、IMU芯片、充电芯片、电池、地磁传感器


# **生产要素数据**

> 生产细节的模板

> 表 shoes_produce_catagories

重要字段仅两个：

- purpose: 生产/销售/管理之用途（或称大类），例如  compo-电子元件、part-鞋体部位、acc-出厂配件，未来可能会添加  express-快递

- catagory: 具体的生产/销售/管理实体之分类，例如 电子元件中的IMU芯片、鞋体部位中的大底、出厂配件中的充电器。在shoes_{component|part|accessory}表中，会直接存储catagory具体值

---
<br>



# **供应商**
> 这里仅提关键字段

- 厂商名
- 厂商性质
- 对接业务
- 联系人
- 大分类
    - 电子元件
    - 鞋体部位
    - 出厂(大货)配件

---
<br>


# **生产批次**

### 基本信息

- 批次名: 一般建议以YYYYMM格式开头，再追加不到10个字的描述，以便一目了然。
- 说明
- 计划开工时间
- 计划完成时间
- 状态
    > 详见后台代码 ShoesBatch::$statusMap
    > - 未知状态
    > - 未如期开工
    > - 未开始
    > - 进行中
    > - 已完成
    > - 已超时

### 详细信息

- 具体生产细节(生产明细)

    > 表 shoes_accessory/shoes_component/shoes_part
    >
    > 保存关键字段
    > - batch_id (批次)
    > - purpose (用途，取自> shoes_produce_categories表)
    > - catagory (生产要素分类，取自shoes_produce_categories表)
    > - supplier_id (供应商)
    > - description
    >
    > 对应的文件上传

- 鞋子设计摘要

    > 表 shoes_batch 的字段 
    > - design_images （多张图，每张图可设定专用描述）
    >
    >       [{"src":"http://static.ouj.com/shoes-production/ca56601a61b31d87c2be904ddea23647_size10x10_631.jpg","desc":"1"},{"src":"http://static.ouj.com/shoes-production/1dc29431d5c6f9d96dbd0397f23f299f_size1280x720_116120.jpg","desc":"2"}]
    > 
    > - design_desc （鞋子设计的全局描述）
    >
    > 对应的文件上传

- 生产数量摘要

    > 表 shoes_batch 的 quantity_json 字段 
    >
    >       {"quantity_sum":"","quantity_male":"55","quantity_female":"","quantity_child":"","quantity_desc":""}
    >
    > 对应的文件上传

